'************************************************************************
' STOPPUHR.BAS = Komfort-Stoppuhr mit h, min, sec und 1/10 sec Anzeige
' ============
' Dieses Q(uick)Basic-Programm nutzt den System-TIMER zur
' Realisierung einer Stoppuhr, die die seit dem Start vergangenen
' Stunden, Minuten und Sekunden sowie die 1/10 Sekunden anzeigt.
' Das Nullsetzen des TIMERS um Mitternacht wird beruecksichtigt,
' so dass das Programm auch um 0:00 h herum richtig funktioniert.
' Dies habe ich getestet, indem ich die PC-Zeit auf einen Wert kurz
' vor Mitternacht gestellt und dann die Stoppuhr gestartet habe.
' Die maximal messbare Zeit betraegt 24h.
'
' (c) Thomas Antoni, 6.4.05 - 14.12.05
'************************************************************************


'----- rote Bildschirmumrandung malen -----------------------------------
COLOR 4, 7                     'rote Schrift auf Hellgrau
WIDTH 40, 25                   'halb breiter Bildschirm mit 40 Spalten
CLS
LOCATE 1, 1: PRINT STRING$(40, CHR$(219));
FOR Zeile% = 2 TO 24
  LOCATE Zeile%, 1: PRINT CHR$(219);
  LOCATE Zeile%, 40: PRINT CHR$(219);
NEXT
LOCATE 25, 1: PRINT STRING$(40, CHR$(219));
'
'----- Titelzeile anzeigen ----------------------------------------------
COLOR 15, 4                     'weisse Schrift auf rot
LOCATE 1, 13
PRINT "Stoppuhr V1.1";
LOCATE 25, 7
PRINT "(c)Thomas Antoni, 12.2005";
'
'-------------- Bedienhinweise anzeigen ---------------------------------
COLOR 0, 7               'Schwarz auf Hellgrau
LOCATE 5, 8: PRINT " Start/Stopp...[Leertaste]"
LOCATE 6, 8: PRINT " Rcksetzen....[Entf]"
LOCATE 7, 8: PRINT " Beenden.......[Esc]"
'
'-------------- Variablen initialisieren  -------------------------------
Sekunden! = 0
StartZeit! = TIMER
Uhrlaeuft% = 0           'Merker "Uhr ist angehalten"
COLOR 0, 7               'Zeitanzeige schwarz auf hellgrau
'
'-------------- Tasten abfragen  ----------------------------------------
DO
Taste$ = INKEY$
'
SELECT CASE Taste$
  CASE CHR$(32)          'Leertaste  -> Start/Stopp-Zustand wechseln
    StartZeit! = TIMER - Sekunden!
    Uhrlaeuft% = NOT Uhrlaeuft%
  CASE CHR$(0) + "S"     'Entf-Taste -> Stoppuhr ruecksetzen
    Sekunden! = 0        'Stoppuhr auf 0 setzen ...
    Uhrlaeuft% = 0       '... und anhalten
  CASE CHR$(27)          'Esc-Taste   -> Programm beendeni
    END
END SELECT
'
'-------------- Zeit in Sekunden ermitteln ------------------------------
IF Uhrlaeuft% THEN
  IF StartZeit! > TIMER THEN  'Ist des Ruecksetzen des TIMERs
                              'um Mitternacht erfolgt?
    Sekunden! = TIMER + 86400 - StartZeit!
                              'Ruecksetzen kompensieren
  ELSE
    Sekunden! = TIMER - StartZeit! 'kein Mitternachtssprung
  END IF
END IF
'
'-------------- Stunden, Minuten u. Sekunden fuer Anzeige ermitteln -----
'DOUBLE-Gleitpunktformat # verwenden, um die Rundungsfehler klein zu
'halten.
Sekunden# = CDBL(Sekunden!)       'Typumwandlung in DOUBLE
Stunden& = INT(Sekunden# / 3600#)
Minuten& = INT((Sekunden# - Stunden& * 3600#) / 60#)
Sekundenanzeige# = Sekunden# - Stunden& * 3600# - Minuten& * 60#
'
Sekunden$ = RIGHT$(STR$(CLNG(Sekundenanzeige# * 10) + 10 ^ 3), 3)
  'Anzuzeigende Sekunden mit 2 Vor- und 1 Nachkommastelle (gerundet),
  'fehlende Vorkommastellen links durch Nullen dargestellt. Der Dezimal-
  'punkt fehlt
Minuten$ = RIGHT$(STR$(Minuten& + 100), 2)
Stunden$ = RIGHT$(STR$(Stunden& + 100), 2)
'
'-------------- Stoppuhr und Uhrzeit anzeigen ---------------------------
COLOR 15, 1              'Stoppuhranzeige Weiss auf Blau
LOCATE 13, 14: PRINT SPACE$(12)
LOCATE 15, 14: PRINT SPACE$(12)
LOCATE 14, 14
PRINT " "; Stunden$; ":"; Minuten$; ":";
PRINT LEFT$(Sekunden$, 2); ","; RIGHT$(Sekunden$, 1); " "
COLOR 0, 7               'Uhrzeitanzeige Schwarz auf Hellgrau
LOCATE 17, 16
PRINT TIME$
LOOP



